/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package eu.himeros.ocr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import org.apache.fop.hyphenation.Hyphenation;
import org.apache.fop.hyphenation.HyphenationTree;
import org.apache.fop.hyphenation.Hyphenator;

/**
 *
 * @author federico
 */
public class TextEvaluator {

								int n;
								String inputFileName = null;
								BufferedReader br = null;
								BufferedWriter bw = null;
								BufferedReader grcBr = null;
								BufferedReader upGrcBr = null;
								BufferedReader syllBr = null;
								HashSet<String> grcHs = new HashSet<String>();
								HashSet<String> upGrcHs = new HashSet<String>();
								HashSet<String> syllHs = new HashSet<String>();
								ArrayList wordL = new ArrayList();
								HyphenationTree htree = null;
								double tot = 0;
								double lev1 = 0;
								double lev2 = 0;
								double lev3 = 0;
								double lev4 = 0;
								double lev5 = 0;
								double lev6 = 0;

								public TextEvaluator() throws FileNotFoundException, IOException, ClassNotFoundException {
																init();
								}

								public void serialize() throws FileNotFoundException, IOException {
																grcBr = new BufferedReader(new FileReader("greek.dic"));
																upGrcBr = new BufferedReader(new FileReader("upgreek.dic"));
																syllBr = new BufferedReader(new FileReader("syllgreek.dic"));
																String line = null;
																while ((line = grcBr.readLine()) != null) {
																								grcHs.add(line);
																}
																while ((line = upGrcBr.readLine()) != null) {
																								upGrcHs.add(line);
																}
																while ((line = syllBr.readLine()) != null) {
																								syllHs.add(line);
																}


																ObjectOutput out = new ObjectOutputStream(new FileOutputStream("grchs.ser"));
																out.writeObject(grcHs);
																out.close();

																out = new ObjectOutputStream(new FileOutputStream("upgrchs.ser"));
																out.writeObject(upGrcHs);
																out.close();

																out = new ObjectOutputStream(new FileOutputStream("syllhs.ser"));
																out.writeObject(syllHs);
																out.close();

								}

								public void init() throws IOException, ClassNotFoundException {
																//initDir = System.getProperty("init.dir") + File.separator;
																System.err.println("start init");
																//htree = Hyphenator.getUserHyphenationTree("el_EL", initDir + "hyph");
																htree=Hyphenator.getFopHyphenationTree("el_EL");
																System.err.println("hyph loaded");

																//bw = new BufferedWriter(new FileWriter("output.txt"));
																//ObjectInputStream in = new ObjectInputStream(new FileInputStream(initDir + "grchs.ser"));
																ObjectInputStream in = new ObjectInputStream(ClassLoader.getSystemResourceAsStream("eu/himeros/resources/grchs.ser"));
																grcHs = (HashSet) in.readObject();
																in.close();
																System.err.println("grcHs loaded");

																in = new ObjectInputStream(ClassLoader.getSystemResourceAsStream("eu/himeros/resources/upgrchs.ser"));
																upGrcHs = (HashSet) in.readObject();
																in.close();
																System.err.println("upGrcHs loaded");

																in = new ObjectInputStream(ClassLoader.getSystemResourceAsStream("eu/himeros/resources/syllhs.ser"));
																syllHs = (HashSet) in.readObject();
																in.close();
																System.err.println("syllHs loaded");

								}

								public void eval(String fileName) throws IOException {
																lev1 = 0;
																lev2 = 0;
																lev3 = 0;
																lev4 = 0;
																lev5 = 0;
																lev6 = 0;
																tot = 0;
																wordL.clear();
																br = new BufferedReader(new FileReader(fileName));
																String outFileName = fileName.replaceAll("(\\..*)$", "") + "-eval.txt";
																bw = new BufferedWriter(new FileWriter(outFileName));
																String line = null;
																String prevPart = "";
																while ((line = br.readLine()) != null) {
																								String[] words = line.split(" ");
																								for (int i = 0; i < words.length; i++) {
																																if (i == 0) {
																																								wordL.add(prevPart + words[i]);
																																								prevPart = "";
																																}
																																if (i == words.length - 1) {
																																								if (words[i].length() > 0 && words[i].charAt(words[i].length() - 1) == '-') {
																																																prevPart = words[i].substring(0, words[i].length());
																																								} else {
																																																wordL.add(prevPart + words[i]);
																																								}
																																} else if (i != 0) {
																																								wordL.add(words[i]);
																																}
																								}
																}
																Iterator<String> it = wordL.iterator();
																String val = "";
																String sample = null;
																String sampleOrig = null;
																while (it.hasNext()) {
																								val = "";
																								sampleOrig = it.next();
																								sample = sampleOrig.replaceAll("[.,;\u0387\\(\\)]", "");
																								if (grcHs.contains(sample) || sample.matches("[0-9]+")) {
																																lev1++;
																																val = "word";
																								} else if (upGrcHs.contains(sample)) {
																																lev2++;
																																val = "WORD";
																								} else if (testSyllSeq(sample)) {
																																lev3++;
																																val = "syll";
																								} else if (testCharSeq(sampleOrig) && sampleOrig.length() > 1) {
																																lev4++;
																																val = "char";
																								} else {
																																if (sampleOrig.length() > 1) {
																																								lev5++;
																																								val = "bad+";
																																} else if (sampleOrig.equals("\n")) {
																																								//do nothing!				
																																} else {
																																								lev6++;
																																								val = "bad1";
																																}
																																//val = "bad1";
																								}
																								//System.out.println(sampleOrig + "\t : " + val);
																								bw.write(sampleOrig + "\t : " + val);
																								bw.newLine();
																}
																//System.out.println(fileName+" report:");
																bw.write(fileName + " report:");
																bw.newLine();
																double totwords = lev1 + lev2 + lev3 + lev4 + lev5 + lev6;
																//System.out.println("totWords: " + totwords);
																bw.write("totWords: " + totwords);
																bw.newLine();
																//System.out.println("dictionary     words  : " + lev1);
																bw.write("dictionary     words  : " + lev1);
																bw.newLine();
																//System.out.println("uppercase      words  : " + lev2);
																bw.write("uppercase      words  : " + lev2);
																bw.newLine();
																//System.out.println("good  syllabic  seq.  : " + lev3);
																bw.write("good  syllabic  seq.  : " + lev3);
																bw.newLine();
																//System.out.println("Greek character seq.  : " + lev4);
																bw.write("Greek character seq.  : " + lev4);
																bw.newLine();
																//System.out.println("bad   character seq.  : " + lev5);
																bw.write("bad   character seq.  : " + lev5);
																bw.newLine();
																//System.out.println("bad single characters : " + lev6);
																bw.write("bad single characters : " + lev6);
																bw.newLine();
																bw.write("score : " + ((lev1 + lev2 * .75 + lev3 * .5 + lev4 * .25) / totwords));
																bw.newLine();
																bw.close();
								}

								private boolean testSyllSeq(String str) {
																boolean res = false;
																Hyphenation hp = null;
																hp = htree.hyphenate(str, 0, 0);
																try{
																							//	System.out.println(hp.toString());
																}catch(Exception exx){}
																int beg = 0;
																int end = str.length();
																int[] poss;
																if (hp == null) {
																								poss = new int[1];
																								poss[0] = end;
																} else {
																								int[] ips = hp.getHyphenationPoints();
																								poss = new int[ips.length + 1];
																								System.arraycopy(ips, 0, poss, 0, ips.length);
																								poss[poss.length - 1] = end;
																}
																int pos;
																String syll = "";
																for (int idx = 0; idx < poss.length; idx++) {
																								if (idx < poss.length - 1) {
																																pos = poss[idx] + 1;
																																if (idx == 0) {
																																								syll = "^";
																																} else {
																																								syll = "";
																																};
																																syll += str.substring(beg, pos);
																								} else {
																																pos = poss[idx];
																																syll = "" + str.substring(beg, pos) + "#";
																								}
																								beg = poss[idx];
																								if (syllHs.contains(syll)) {
																																res = true;
																								} else {
																																return false;
																								}
																}

																//!!!
																return res;
								}

								private boolean testCharSeq(String str) {
																return str.matches("[\\(]?[’\u0370-\u0386\u0388-\u03FF\u1F00-\u1FFF]+[.,;\u0387\\)]?");
								}

								public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {

																TextEvaluator te = new TextEvaluator();
																File f = new File(args[0]);
																if (f.isDirectory()) {
																								File[] files = f.listFiles();
																								for (File file : files) {
																																te.eval(file.getCanonicalPath());
																								}
																} else {
																								te.eval(f.getCanonicalPath());
																}
								}
}
